//WHICHLIB JOB (001),'ASM WHICHLIB    ',CLASS=A,MSGCLASS=X              00000100
//       EXEC ASMFCL,                                                   00000200
//            PARM.ASM='LIST,LOAD,NODECK,XREF(SHORT)',                  00000301
//            REGION.ASM=1M,                                            00000400
//            MAC1='SYS1.AMODGEN'                                       00000500
//ASM.SYSPRINT DD SYSOUT=*                                              00000600
//ASM.SYSIN DD *                                                        00000700
         PRINT ON,NOGEN                                                 00000800
         TITLE 'RETURN LIBRARY WHERE LOAD MODULE EXISTS'                00000900
*_DOC_***************************************************************** 00001000
*                                                                     * 00001100
* THE PRIMARY FUNCTION OF THIS PROGRAM IS TO DETERMINE IF A LOAD      * 00001200
* MODULE IS AVAILABLE FOR EXECUTION AND, IF NOT, SET THE RETURN CODE  * 00001300
* TO 0001. IF THE LOAD MODULE IS AVAILABLE, THE RETURN CODE WILL BE   * 00001400
* SET TO 0000.  IF AN OPTIONAL SYSPRINT DD STATEMENT IS PROVIDED, A   * 00001500
* SINGLE LINE IS PRODUCED IDENTIFYING THE LIBRARY WHERE THE LOAD      * 00001600
* MODULE WAS FOUND.                                                   * 00001700
*                                                                     * 00001800
* THE PROGRAM IS SELF CONTAINED; SIMPLY ASSEMBLE AND LINK AND IT IS   * 00001900
* READY TO USE.                                                       * 00002000
*                                                                     * 00002100
* THE JCL TO EXECUTE WHICHLIB IS:                                     * 00002200
*   1) //         EXEC PGM=WHICHLIB,PARM='????????' <-MODULE TO FIND  * 00002300
*   2) //SYSPRINT DD  SYSOUT=*                      <-OPTIONAL        * 00002400
*                                                                     * 00002500
* UPDATE 2024/05/25 - IT IS PERMISSIBLE FOR PARMLIB MEMBERS TO HAVE   * 00002601
* BLANKS PRECEED VALUES, SO I HAVE ADDED CODE TO ENSURE THAT AFTER    * 00002701
* A RECORD IS READ FROM SYS1.PARMLIB, THE DATA IN THE STATEMENT IS    * 00002801
* LEFT JUSTIFIED BEFORE TESTING FOR ENTRIES BEING SEARCHED FOR.       * 00002901
*                                                                     * 00003001
*********************************************************************** 00003101
WHICHLIB CSECT                                                          00003201
         B     BEGIN-*(,R15)           BRANCH AROUND EYECATCHER         00003301
         DC    AL1(BEGIN-ID)                                            00003401
ID       DC    C'WHICHLIB '                                             00003501
         DC    C'&SYSDATE '                                             00003601
         DC    C'&SYSTIME - '                                           00003701
BEGIN    DS    0H                                                       00003801
         SAVE  (14,12)                 SAVE CALLER'S REGISTERS          00003901
         LR    R12,R15                 INITIALIZE BASE REGISTER         00004001
         USING WHICHLIB,R12            ESTABLISH ADDRESSABILITY         00004101
         LR    R6,R1                   SAVE PARAMETER ADDRESS IN R6     00004201
         LA    R10,SAVEAREA            LOAD MY SAVE AREA ADDR           00004301
         ST    R10,8(,R13)             STORE CALLER'S SAVE AREA ADDR    00004401
         ST    R13,4(,R10)             BACK CHAIN MY SAVE AREA ADDR     00004501
         LR    R13,R10                 ESTABLISH MY SAVE AREA           00004601
         SPACE 1                                                        00004701
         L     R6,0(,R6)               POINT TO EXEC PARM               00004801
         LH    R7,0(,R6)               GET LENGTH OF PARM FIELD         00004901
         LTR   R7,R7                   ANY PARM?                        00005001
         BZ    GOBACK                  NO, RETURN TO CALLER             00005101
         LA    R6,2(R6)                FIRST CHAR OF EXEC PARM          00005201
         BCTR  R7,0                    DECREMENT FOR MOVE               00005301
         LA    R2,BLDLNAME             GET ADDRESS TO MOVE TO           00005401
         EX    R7,MOVEPARM             MOVE NAME INTO BLDL              00005501
         B     SCANTIOT                GO FIND SYSPRINT                 00005601
MOVEPARM MVC   0(*-*,R2),0(R6)         EXECUTE MOVE FOR PARM            00005701
*                                                                       00005801
* LOOP THROUGH TIOT LOOKING FOR SYSPRINT DD                             00005901
*                                                                       00006001
SCANTIOT L     R1,CVTPTR               ADDRESS OF CVT                   00006101
         L     R1,CVTTCBP-CVTMAP(,R1)  TCB TABLE                        00006201
         L     R1,4(,R1)               TCBOLD (CURRENT)                 00006301
         L     R1,TCBTIO-TCB(,R1)      TIOT                             00006401
         LA    R1,TIOENTRY-TIOT1(,R1)  LOAD PAST TIOT HEADER            00006501
         USING TIOENTRY,R1             ESTABLISH ADDRESSABILITY         00006601
         SR    R2,R2                                                    00006701
LOOPTIOT IC    R2,TIOELNGH             GET ENTRY LENGTH                 00006801
         LTR   R2,R2                   LAST ENTRY PASSED?               00006901
         BZ    DONETIOT                YES, GET OUT                     00007001
         CLC   TIOEDDNM,=C'SYSPRINT'   IS THIS SYSPRINT DD?             00007101
         BNE   NEXTTIOT                NO, CHECK NEXT                   00007201
         MVI   SYSPRT,C'Y'             SET FLAG FOR SYSPRINT SUPPLIED   00007301
         B     DONETIOT                FINISHED, EXIT                   00007401
NEXTTIOT AR    R1,R2                   BUMP TO NEXT TIOT ENTRY          00007501
         B     LOOPTIOT                LOOP                             00007601
DONETIOT DS    0H                      FINISHED WITH TIOT               00007701
         DROP  R1                                                       00007801
*                                                                       00007901
* SEE IF LOAD MODULE CAN BE FOUND                                       00008001
*                                                                       00008101
         BLDL  0,BLDLLIST              BLDL FROM TASK/STEP/JOBLIB       00008201
         LTR   R15,R15                 WAS MODULE NAME FOUND ?          00008301
         BZ    PRTREQ                  YES, GO SEE IF SYSPRINT PROVIDED 00008401
NOTFOUND MVC   RETCODE,=F'1'           SET RETCODE = 1                  00008501
         B     GOBACK                  RETURN                           00008601
PRTREQ   CLI   SYSPRT,C'Y'             WAS SYSPRINT PROVIDED?           00008701
         BNE   GOBACK                  NO, JUST RETURN                  00008801
         SPACE 1                                                        00008901
         MVC   MODNAME,BLDLNAME        MOVE MODULE NAME TO PRINT        00009001
*                                                                       00009101
* SET WHICH LIBRARY WAS MODULE FOUND IN                                 00009201
*   SEE: (SYS1.AMODGEN(IHAPDS)@PDS2LIBF)                                00009301
*                                                                       00009401
LIBSTAT  MVC   LIBRARY,JOBSTEP                                          00009501
         CLI   LOCCODE,X'02'           IS IT IN JOBSTEP ?               00009601
         BE    CONCATON                YES                              00009701
         MVC   LIBRARY,LINKLST                                          00009801
         CLI   LOCCODE,X'01'           IS IT IN THE LINKLST ?           00009901
         BE    LINKLIST                YES                              00010001
         MVC   LIBRARY(16),UNKNLIB     UNKNOWN LIBRARY                  00010101
         B     PRINTIT                 GO PRINT                         00010201
*                                                                       00010301
* SET CONCATENATION NUMBER                                              00010401
*                                                                       00010501
CONCATON SR    R1,R1                                                    00010601
         IC    R1,CONCAT#              CONCATENATION NUMBER TO R1       00010701
         LA    R1,1(,R1)               ADJUST FOR ZERO BASE             00010801
         CVD   R1,DWORK                CONVERT TO DECIMAL               00010901
         ED    CWORK,DWORK+6           EDIT                             00011001
         MVC   CONCAT,CWORK+2          MOVE TO PRINT                    00011101
         B     PRINTIT                 GO PRINT                         00011201
         SPACE 1                                                        00011301
*                                                                       00011401
* FIND LINKLIST LIBRARY INFORMATION                                     00011501
*                                                                       00011601
LINKLIST SR    R8,R8                                                    00011701
         IC    R8,CONCAT#              LINKLIST ENTRY NUMBER TO R8      00011801
         LA    R8,1(,R8)               ADJUST FOR ZERO BASE             00011901
         CVD   R8,DWORK                CONVERT TO DECIMAL               00012001
         ED    CWORK,DWORK+6           EDIT                             00012101
         MVC   CONCAT,CWORK+2          MOVE TO PRINT                    00012201
*                                                                       00012301
* READ SYS1.PARMLIB(IEASYS00) TO GET LNKLST PARM MEMBER                 00012401
*                                                                       00012501
         MVC   RBVERB,=AL1(S99VRBAL)   SET VERB CODE TO ALLOC           00012601
         MVC   RBTEXTA,=A(TEXTLST1)    SET TU LIST FOR ALLOC            00012701
         BAL   R14,DYNALLOC            ALLOCATE PARMLIB (IEASYS00)      00012801
         LTR   R15,R15                 SUCCESS?                         00012901
         BNZ   PRINTIT                 NO, JUST GO PRINT                00013001
         SPACE 1                                                        00013101
         OPEN  (PARMLIB,(INPUT))       OPEN PARMLIB (IEASYS00)          00013201
PREADI1  GET   PARMLIB,PARMSTMT        READ PARMLIB (IEASYS00)          00013301
         CALL IFMTLJST,(PARMSTMT,L4)   ENSURE NO LEADING SPACES         00013401
         CLC   PARMSTMT(4),=CL4'LNK='  IS THIS LNKLST ID?               00013501
         BNE   PREADI1                 NO, CONTINUE READING             00013601
PREADE1  CLOSE PARMLIB                 CLOSE PARMLIB (IEASYS00)         00013701
         MVC   RBVERB,=AL1(S99VRBUN)   SET VERB CODE TO FREE            00013801
         MVC   RBTEXTA,=A(TEXTLST2)    SET TU LIST FOR FREE             00013901
         BAL   R14,DYNALLOC            UN-ALLOCATE PARMLIB              00014001
         LTR   R15,R15                 SUCCESS?                         00014101
         BNZ   PRINTIT                 NO, JUST GO PRINT                00014201
         SPACE 1                                                        00014301
         MVC   $MEM(6),=CL6'LNKLST'    SET MEMBER NAME TO LNKLST        00014401
         MVC   $MEM+6(2),PARMSTMT+4    PLUS ID FROM IEASYS00            00014501
*                                                                       00014601
* READ SYS1.PARMLIB(LNKLST??) TO GET LINK LIST DATASET NAMES            00014701
*                                                                       00014801
         MVC   RBVERB,=AL1(S99VRBAL)   SET VERB CODE TO ALLOC           00014901
         MVC   RBTEXTA,=A(TEXTLST1)    SET TU LIST FOR ALLOC            00015001
         BAL   R14,DYNALLOC            ALLOCATE PARMLIB (LNKLST??)      00015101
         LTR   R15,R15                 SUCCESS?                         00015201
         BNZ   PRINTIT                 NO, JUST GO PRINT                00015301
         SPACE 1                                                        00015401
         OPEN  (PARMLIB,(INPUT))       OPEN PARMLIB (LNKLST??)          00015501
         MVC   PARMLIB+33(3),=AL3(PREADE2) SET NEW EOF ADDRESS          00015601
         MVI   LLABORT,C'N'            IF NOT FOUND                     00015701
         XR    R7,R7                   TO COUNT STATEMENTS READ         00015801
PREADI2  GET   PARMLIB,PARMSTMT        READ PARMLIB (LNKLST??)          00015901
         CALL IFMTLJST,(PARMSTMT,L4)   ENSURE NO LEADING SPACES         00016001
         LA    R7,1(,R7)               COUNT STATEMENT READ             00016101
         CR    R7,R8                   IS THIS THE ONE WE NEED?         00016201
         BL    PREADI2                 R7<R8, CONTINUE READING          00016301
         BNE   PREADE2                 R7\=R8, CLOSE & CONTINUE         00016401
         SPACE 1                                                        00016501
         MVI   LLABORT,C'Y'            R7=R8, FOUND                     00016601
         SPACE 1                                                        00016701
PREADE2  CLOSE PARMLIB                 CLOSE PARMLIB (LNKLST??)         00016801
         MVC   RBVERB,=AL1(S99VRBUN)   SET VERB CODE TO FREE            00016901
         MVC   RBTEXTA,=A(TEXTLST2)    SET TU LIST FOR FREE             00017001
         BAL   R14,DYNALLOC            UN-ALLOCATE PARMLIB              00017101
         SPACE 1                                                        00017201
         CLI   LLABORT,C'N'            WAS LIBRARY FOUND?               00017301
         BE    PRINTIT                 NO, JUST GO PRINT                00017401
         SPACE 1                                                        00017501
         LA    R1,PARMSTMT             ADDRESS PARM STATEMENT           00017601
PSCANL   CLI   0(R1),KCOMMA            FOUND COMMA?                     00017701
         BE    PSCANX                  YES, PROCESS                     00017801
         CLI   0(R1),KSPACE            FOUND SPACE?                     00017901
         BE    PSCANX                  YES, PROCESS                     00018001
         CLI   0(R1),KLPAREN           FOUND LEFT PAREN?                00018101
         BE    PSCANX                  YES, PROCESS                     00018201
         LA    R1,1(,R1)               INCREMENT SCAN POSITION          00018301
         B     PSCANL                  LOOP TO CONTINUE SCANNING        00018401
         SPACE 1                                                        00018501
PSCANX   S     R1,=A(PARMSTMT)         COMPUTE LENGTH OF DSN            00018601
GETDSN   MVI   CAMDSN,KSPACE           CLEAR FIELD TO                   00018701
         MVC   CAMDSN+1(L'CAMDSN-1),CAMDSN   SPACES TO RECEIVE DSN      00018801
         BCTR  R1,0                    DECREMENT FOR EX                 00018901
         EX    R1,MOVEDSN              MOVE DSN TO CAMLST AREA          00019001
         LA    R4,LLINFO               ADDRESS PRINT AREA               00019101
         MVC   0(44,R4),CAMDSN         MOVE DSN TO PRINT                00019201
         AR    R4,R1                   ADDRESS PRINT AREA PAST DSN      00019301
         LA    R4,2(,R4)               BUMP TO NEXT PRINT LOCATION      00019401
         MVC   0(2,R4),=C'ON'          MOVE LITERAL TO PRINT            00019501
         LA    R4,3(,R4)               BUMP TO NEXT OUTPUT POSITION     00019601
         SPACE 1                                                        00019701
         LOCATE BYNAME                 LOCATE                           00019801
         MVC   0(6,R4),VSERIAL         MOVE VOLSER TO PRINT             00019901
         B     PRINTIT                 GO PRINT                         00020001
         SPACE 1                                                        00020101
MOVEDSN  MVC   CAMDSN(*-*),PARMSTMT    EXECUTED MOVE                    00020201
         SPACE 1                                                        00020301
PRINTIT  OPEN  (SYSPRINT,(OUTPUT))     OPEN SYSPRINT                    00020401
         PUT   SYSPRINT,FOUNDMSG       WRITE PRINT LINE                 00020501
         CLOSE SYSPRINT                CLOSE SYSPRINT                   00020601
         SPACE 1                                                        00020701
GOBACK   DS    0H                      RETURN TO CALLER                 00020801
         L     R13,4(,R13)             RELOAD PREVIOUS SAVE AREA        00020901
         L     R15,RETCODE             LOAD RETURN CODE                 00021001
         RETURN (14,12),RC=(15)                                         00021101
         SPACE 1                                                        00021201
*                                                                       00021301
* ALLOCATE DSN(MEMBER)                                                  00021401
*                                                                       00021501
DYNALLOC DS    0H                                                       00021601
         LA    R1,RBA                  LOAD REQUEST BLOCK ADDRESS       00021701
         DYNALLOC                      CALL DYNAMIC ALLOCATE SVC        00021801
         BR    R14                     RETURN                           00021901
         SPACE 1                                                        00022001
FOUNDMSG DS    0CL133                                                   00022101
         DC    CL1'1'                                                   00022201
MODNAME  DC    CL8'        '                                            00022301
         DC    CL14' WAS FOUND IN '                                     00022401
LIBRARY  DC    CL12'            '                                       00022501
         DC    CL1'('                                                   00022601
CONCAT   DC    CL2' '                                                   00022701
         DC    CL1')'                                                   00022801
         DC    CL1' '                                                   00022901
LLINFO   DC    CL93' '                                                  00023001
JOBSTEP  DC    CL12'JOB/STEP LIB'                                       00023101
LINKLST  DC    CL12'LINKLIST LIB'                                       00023201
UNKNLIB  DC    CL16'UNKNOWN LIB     '                                   00023301
DWORK    DS    D                       CONVERT TO DECIMAL WORK          00023401
CWORK    DC    XL4'40212020'           CONVERT TO PRINTABLE WORK        00023501
         SPACE 1                                                        00023601
BLDLLIST DS    0H                      PARM LIST FOR BLDL               00023701
         DC    H'01'                   NUMBER OF ENTRIES                00023801
         DC    H'14'                   BYTES PER ENTRY                  00023901
BLDLNAME DC    CL8' '                  NAME OF LOAD MODULE              00024001
TTR1REC  DC    CL3'0'                  TTR OF FIRST RECORD              00024101
CONCAT#  DC    X'0'                    K BYTE, CONCATENATED NUMBER      00024201
LOCCODE  DC    X'0'                    Z BYTE, LOCATION CODE            00024301
FLGUSRD  DC    X'0'                    C BYTE, FLAG AND USER DATA LEN   00024401
         SPACE 1                                                        00024501
RBA      DC    A(X'80000000'+RB)       DYNALLOC REQUEST BLOCK ADDRESS   00024601
RB       DC    AL1(S99RBEND-S99RB)     DYNALLOC REQUEST BLOCK LENGTH    00024701
RBVERB   DC    AL1(S99VRBAL)           DYNALLOC VERB 01=ALLOC/02=FREE   00024801
RBFLAGS1 DC    AL1(S99NOMNT,0)         DYNALLOC FLAGS 1                 00024901
*                  S99NOMNT                 DO NOT MOUNT VOLUMES        00025001
RBERROR  DC    AL2(0)                  DYNALLOC ERROR CODE              00025101
RBINFO   DC    AL2(0)                  DYNALLOC INFORMATION CODE        00025201
RBTEXTA  DC    A(TEXTLST1)             DYNALLOC ADDR OF TEXT UNIT LIST  00025301
RBEXTNA  DC    A(0)                    DYNALLOC ADDR OF RB EXTENSION    00025401
RBFLAGS2 DC    A(0)                    DYNALLOC FLAGS 2                 00025501
         SPACE 1                                                        00025601
TEXTLST1 DC    A(TUDD)                 DYNALLOC TU LIST (ALLOC)         00025701
         DC    A(TUDSN)                                                 00025801
         DC    A(TUMEM)                                                 00025901
         DC    A(X'80000000'+TUDISP)                                    00026001
TEXTLST2 DC    A(TUDD)                 DYNALLOC TU LIST (FREE)          00026101
         DC    A(X'80000000'+TUFREE)                                    00026201
         SPACE 1                                                        00026301
TUDD     DC    Y(DALDDNAM,1,8),CL8'PARMLIB' TU: DD NAME                 00026401
TUDSN    DC    Y(DALDSNAM,1)                TU: DSN                     00026501
$DSNLEN  DC    AL2(L'$DSN)                                              00026601
$DSN     DC    CL44'SYS1.PARMLIB'                                       00026701
TUMEM    DC    Y(DALMEMBR,1)                TU: MEMBER NAME             00026801
$MEMLEN  DC    AL2(L'$MEM)                                              00026901
$MEM     DC    CL8'IEASYS00'                                            00027001
TUDISP   DC    Y(DALSTATS,1,1)              TU: DISP=SHR                00027101
         DC    X'08'                                                    00027201
TUFREE   DC    Y(DUNUNALC,0)                TU: FREE                    00027301
         SPACE 1                                                        00027401
BYNAME   CAMLST NAME,CAMDSN,,CAMWORK   LOCATE ARGUMENTS                 00027501
CAMDSN   DS    CL44                    DS NAME TO SEARCH FOR            00027601
CAMWORK  DS    0D                      CAMLST WORK AREA                 00027701
         DC    265CL1' '                                                00027801
         ORG   CAMWORK+6                                                00027901
VSERIAL  DS    CL6                     VOLUME SERIAL RETURNED           00028001
         ORG                                                            00028101
         SPACE 1                                                        00028201
SAVEAREA DC    18F'0'                  MY SAVE AREA                     00028301
SYSPRT   DC    CL1'N'                  FLAG FOR SYSPRINT DD SUPPLIED    00028401
RETCODE  DC    F'0'                    RETURN CODE                      00028501
L4       DC    H'80'                   LENGHT OF PARMSTMT               00028601
LLABORT  DC    CL1'N'                  FLAG FOR LINKLISTLIB NOT FOUND   00028701
         PRINT ON,NOGEN                                                 00028801
SYSPRINT DCB   DDNAME=SYSPRINT,MACRF=PM,RECFM=FBA,LRECL=133,           C00028901
               BLKSIZE=1330,DSORG=PS                                    00029001
PARMLIB  DCB   DDNAME=PARMLIB,MACRF=GM,RECFM=FB,LRECL=80,              C00029101
               BLKSIZE=80,DSORG=PS,EODAD=PREADE1                        00029201
PARMSTMT DS    CL80                PARMLIB INPUT AREA                   00029301
R0       EQU   0                                                        00029401
R1       EQU   1                                                        00029501
R2       EQU   2                                                        00029601
R3       EQU   3                                                        00029701
R4       EQU   4                                                        00029801
R5       EQU   5                                                        00029901
R6       EQU   6                                                        00030001
R7       EQU   7                                                        00030101
R8       EQU   8                                                        00030201
R9       EQU   9                                                        00030301
R10      EQU   10                                                       00030401
R11      EQU   11                                                       00030501
R12      EQU   12                                                       00030601
R13      EQU   13                                                       00030701
R14      EQU   14                                                       00030801
R15      EQU   15                                                       00030901
*                                                                       00031001
KSPACE   EQU   X'40'                   SPACE                            00031101
KSTAR    EQU   C'*'                    ASTERISK                         00031201
KCOMMA   EQU   C','                    COMMA                            00031301
KLPAREN  EQU   C'('                    LEFT PAREN                       00031401
KRPAREN  EQU   C')'                    RIGHT PAREN                      00031501
*                                                                       00031601
         CVT   DSECT=YES                                                00031701
MYTIOT   DSECT ,                                                        00031801
         IEFTIOT1 ,                                                     00031901
         IKJTCB   ,                                                     00032001
         IEFZB4D0 ,                    SVC99 REQUEST BLOCK              00032101
         IEFZB4D2 ,                    SVC99 TEXT UNITS                 00032201
         END                                                            00032301
//LKED.SYSLMOD DD DISP=SHR,DSN=SYSC.LINKLIB                             00032401
//LKED.SYSPRINT DD SYSOUT=*                                             00032501
//LKED.SYSLIB DD DISP=SHR,DSN=SYSC.LINKLIB                              00032601
//LKED.SYSIN DD *                                                       00032701
  INCLUDE SYSLIB(IFMTLJST)                                              00032801
  ENTRY WHICHLIB                                                        00032901
  NAME WHICHLIB(R)                                                      00033001
//                                                                      00033101
